#ifndef CALLBACKS_H
#define CALLBACKS_H

#include <gnome.h>
#include <sys/types.h>
#include <signal.h>
#include <wait.h>
#include <gnome.h>
#include <libgnomevfs/gnome-vfs.h>
#include <gtk/gtkdnd.h>
#include <glib.h>

#include "interface.h"

/*nuke this section, move to module*/
gint start_prieview_ac3(const char* filename);
gint start_prieview_mp3(const char* filename);
gint start_prieview_wav(const char* filename);
gboolean stop_preview();
void preview_ac3(const char* filename);
void preview_mp3(const char* filename);
void preview_mp3(const char* filename);

gint animation_handler_callback(gpointer data);
gint progress_handler_callback(gpointer);
gint dequeue_handler_callback(gpointer);
gboolean on_gfilerunner_motion_notify_event(GtkWidget*widget,GdkEventMotion*event,gpointer user_data);
void async_loading_callback(GnomeVFSAsyncHandle*,GnomeVFSResult,GList*,guint,gpointer);
void set_basic_icon_signals(GnomeCanvasItem* item, gpointer data);
gint hack_canvas_events(GnomeCanvasItem *item, GdkEvent*event, gpointer data);
gint bghack_events(GnomeCanvasItem *item, GdkEvent *event, gpointer data);
gint on_menuitem_button_press(GtkWidget*widget,GdkEvent*event,gpointer data);
gint icon_events(GnomeCanvasItem *item, GdkEvent *event, gpointer data);
void on_gfilerunner_check_resize(GtkWidget*widget,gpointer user_data);
void on_delete(GtkMenuItem*menuitem,gpointer user_data);
void on_new_file1_activate(GtkMenuItem*menuitem,gpointer user_data);
void on_openwith_activate(GtkMenuItem*menuitem,gpointer user_data);
void on_script_activate(GtkMenuItem*menuitem,gpointer user_data);
void on_template_activate(GtkMenuItem*menuitem,gpointer user_data);
void on_open1_activate(GtkMenuItem*menuitem,gpointer user_data);
void on_save1_activate(GtkMenuItem*menuitem,gpointer user_data);
void on_save_as1_activate(GtkMenuItem*menuitem, gpointer user_data);
void on_exit1_activate(GtkMenuItem*menuitem,gpointer user_data);
void on_cut1_activate(GtkMenuItem*menuitem, gpointer user_data);
void on_copy1_activate (GtkMenuItem*menuitem, gpointer user_data);
void on_paste1_activate(GtkMenuItem*menuitem, gpointer user_data);
void newfolderdlg_callback(gchar*string,gpointer data);
void on_newfolder_activate(GtkMenuItem*menuitem,gpointer user_data);
void on_rename1_activate(GtkMenuItem*menuitem, gpointer user_data);
void renamedlg_callback(gchar*string,gpointer data);
void on_delete1_activate(GtkMenuItem*menuitem, gpointer user_data);
void on_properties1_activate(GtkMenuItem*menuitem, gpointer user_data);
void on_view1_antialiasing_activate(GtkMenuItem*menuitem, gpointer user_data);
void on_preferences1_activate(GtkMenuItem*menuitem, gpointer user_data);
void on_about1_activate(GtkMenuItem*menuitem, gpointer user_data);
void on_btnGo_clicked(GtkButton*button, gpointer user_data);
void on_btnBack_clicked(GtkButton*button, gpointer user_data);
void on_btnForward_clicked (GtkButton*button, gpointer user_data);
void on_btnUp_clicked(GtkButton*button,gpointer user_data);
void on_btnStop_clicked(GtkButton*button, gpointer user_data);
void on_btnRefresh_clicked (GtkButton*button, gpointer user_data);
void on_btnCut_clicked(GtkButton*button, gpointer user_data);
void on_btnCopy_clicked(GtkButton*button, gpointer user_data);
void on_btnPaste_clicked (GtkButton*button, gpointer user_data);
void on_btnTrash_clicked (GtkButton*button, gpointer user_data);
void on_btnUndo_clicked(GtkButton*button, gpointer user_data);
void on_btnSearch_clicked(GtkButton*button, gpointer user_data);
void on_btnHome_clicked(GtkButton*button, gpointer user_data);
void on_ctree_selection_changed (GtkTree*tree, gpointer user_data);
void on_ctree_row_select(GtkCTree *ctree, GList *node, gint column, gpointer user_data);
gboolean on_canvas_destroy_event(GtkWidget*widget,GdkEvent*event,gpointer user_data);
void on_canvas_realize(GtkWidget*widget,GdkEvent*event,gpointer user_data);

#endif
