#ifndef GFILERUNNER_BASIC_ICON_H
#define GFILERUNNER_BASIC_ICON_H

#include "gfilerunner-basic-icon-types.h"

GList*common_pixbufs;               /* I can cache all the standard icons here....as to play nice with remote ppl. */

/* Caching engine */
GdkPoint* get_aspect_dimensions(int w, int h, int scaledwidth,int scaledheight);
gboolean cache_common_pixbuf(const char*file);
GdkPixbuf* get_pixbuf(const char*file);
GdkPixbuf* _get_pixbuf(const char*file);
GdkPixbuf*get_mime_icon(const char*mime_type);
void free_common_pixbufs(void);

/* Basic stuff */
basic_icon* basic_icon_new(const GnomeCanvasGroup*owner,const char*caption,const char*icon_filename,const char*preview_icon_filename,gdouble myX,gdouble myY,basic_icon_Decoration decoration);
void basic_icon_set_icon(basic_icon*icon,GdkPixbuf*pixbuf);
basic_icon* basic_icon_set_caption(basic_icon*icon,const char*caption);
basic_icon* basic_icon_dup(const basic_icon*from);
void basic_icon_free(basic_icon*);

/* Simple visuals for basic_icons */
/* TODO:  Look into making these constant vars... */
void basic_icon_move(basic_icon*icon,gdouble xoff,gdouble yoff);
void basic_icon_hide(basic_icon*icon);
void basic_icon_show(basic_icon*icon);
void basic_icon_prelight(basic_icon*);
void basic_icon_unprelight(basic_icon*);
void basic_icon_highlight(basic_icon*);
void basic_icon_unhighlight(basic_icon*);
void basic_icon_show_preview(basic_icon*icon);
void basic_icon_hide_preview(basic_icon*icon);

/* Special effects for basic_icons */
void basic_icon_animate(basic_icon*icon,double);
void basic_icon_reset_animation(basic_icon*icon);
gboolean basic_icon_switch_effect(basic_icon*icon,basic_icon_AnimationMode);

#endif
