//
//  GFileRunner include file
//  By Kyle Davis
//
//  This controls clipboard related functions.
//
#ifndef GFILERUNNER_CLIPBOARD_H
#define GFILERUNNER_CLIPBOARD_H

#include <gnome.h>
#include <libgnomevfs/gnome-vfs.h>
#include "gfilerunner-vfs-object.h"

//Data
//TODO:  Decide whether you are going to actually use TRASH and DUPLICATE
//I added Duplicate and Trash because we may want to use them for the ease of storing info on multiple files between function calls.
typedef enum {CLIPBOARD_CUT,CLIPBOARD_COPY,CLIPBOARD_DUPLICATE,CLIPBOARD_TRASH,CLIPBOARD_DELETE} gfilerunner_clipboard_mode;
typedef struct _gfilerunner_clipboard gfilerunner_clipboard;
struct _gfilerunner_clipboard{
	gfilerunner_clipboard_mode mode;	//What mode to use
	char*uri_prefix;	//URI Prefix for all files in data
	GList*data;		//GList of GnomeVFSFileInfo pointers
};

//Functions
gfilerunner_clipboard* gfilerunner_clipboard_new(void);
void gfilerunner_clipboard_set_prefix(gfilerunner_clipboard*gfrclip, const char* uri_prefix);
void gfilerunner_clipboard_append_file(gfilerunner_clipboard*,gfilerunner_vfs_obj*,gfilerunner_clipboard_mode);
void gfilerunner_clipboard_prepend_file(gfilerunner_clipboard*,gfilerunner_vfs_obj*,gfilerunner_clipboard_mode);
gboolean gfilerunner_clipboard_has_data(gfilerunner_clipboard*gfrclip);
void gfilerunner_clipboard_flush(gfilerunner_clipboard*);
void gfilerunner_clipboard_free(gfilerunner_clipboard*);

#endif