//
//  GFileRunner include file
//  By Kyle Davis
//
//  This controls the file property window related functions.
//
#include <pwd.h>
#include <grp.h>
#include "gfilerunner-file-properties-window.h"

permission_btns* new_permission_btns(){
	 int struct_size=PERM_EXECUTE-PERM_READ+1;
	 permission_btns* permissions=g_new(permission_btns,1);
	 permissions->Nobody=g_new(GtkToggleButton*,struct_size);
	 permissions->Owner=g_new(GtkToggleButton*,struct_size);
	 permissions->Group=g_new(GtkToggleButton*,struct_size);
	 permissions->Other=g_new(GtkToggleButton*,struct_size);
	 permissions->Everyone=g_new(GtkToggleButton*,struct_size);
	 return(permissions);
}

void free_permission_btns(permission_btns*permissions){
	//We don't free the GtkToggleButton's because GTK+ will (and wants to) do it for us!  : )
	 g_free(permissions->Nobody);
	 g_free(permissions->Owner);
	 g_free(permissions->Group);
	 g_free(permissions->Other);
	 g_free(permissions->Everyone);
	 g_free(permissions);
}

//TODO:  Takes a GList* filled with GnomeVFSFileInfo*'s
//TODO:  Set User ID, Set Group ID, Sticky, (U,G,O)+(R,W,X) _ALL_ need to go into a struct!
GtkWidget* show_dlgFileProperties(GnomeVFSFileInfo*file_list){
   GtkWidget *dialog_vbox1;
   GtkWidget *notebookProperties;
   GtkWidget *vbox2;
   GtkWidget *frameObjectInfo;
   GtkWidget *tableObjectInformation;
   GtkWidget *lblFileNames;
   GtkWidget *lblTotalSize;
   GtkWidget *scrolledwin_txtFileName;
   GtkWidget *viewport1;
   GtkWidget *lstFileNames;
   GtkWidget *txtTotalSize;
   GtkWidget *frameMIMEInfo;
   GtkWidget *tableMIMEInfo;
   GtkWidget *lblMIMEType;
   GtkWidget *lblDefaultApp;
   GtkWidget *txtMIMEType;
   GtkWidget *hbox1;
   GtkWidget *txtDefaultApp=NULL;
   GtkWidget *btnModify;
   GtkWidget *tablblGeneral;
   GtkWidget *tablblPermissions;
   GtkWidget *tablePermissions;
   GtkWidget *lblPermR;
   GtkWidget *lblPermW;
   GtkWidget *lblPermX;
   GtkWidget *lblNobody;
   GtkWidget *lblOwner;
   GtkWidget *lblGroup;
   GtkWidget *lblOther;
   GtkWidget *chkNobodyR;
   GtkWidget *chkNobodyW;
   GtkWidget *chkNobodyX;
   GtkWidget *chkOwnerR;
   GtkWidget *chkOwnerW;
   GtkWidget *chkOwnerX;
   GtkWidget *chkGroupR;
   GtkWidget *chkGroupW;
   GtkWidget *chkGroupX;
   GtkWidget *chkOtherR;
   GtkWidget *chkOtherW;
   GtkWidget *chkOtherX;
   GtkWidget *lblEveryone;
   GtkWidget *chkEveryoneR;
   GtkWidget *chkEveryoneW;
   GtkWidget *chkEveryoneX;
   GtkWidget *lblSpecial;
   GtkWidget *chkSUID;
   GtkWidget *chkSGID;
   GtkWidget *chkSticky;
   GtkWidget *lblFileOwner;
   GtkWidget *lblFileGroup;
   GtkWidget *cboFileOwner;
   GtkWidget *cboFileOwner_Entry;
   GtkWidget *cboFileGroup;
   GtkWidget *cboFileGroup_Entry;
   GtkWidget *dialog_action_area1;
   GtkWidget *btnHelp;
   GtkWidget *btnOk;
   GtkWidget *btnCancel;
   GtkTooltips *tooltips;
   GtkWidget* listitem;
   GList* namelist=NULL;
	GnomeVFSMimeApplication*vfsmimeapp;
	gfilerunner_file_properties*gfrFileProperties=g_new(gfilerunner_file_properties,1);
   gfrFileProperties->file_list=file_list;
	tooltips = gtk_tooltips_new();
   
   gfrFileProperties->window = gnome_dialog_new(_("Properties"), NULL);
   gtk_object_set_data(GTK_OBJECT(gfrFileProperties->window), "dlgFileProperties", gfrFileProperties->window);
   gtk_window_set_position(GTK_WINDOW(gfrFileProperties->window), GTK_WIN_POS_NONE);
   gtk_window_set_default_size(GTK_WINDOW(gfrFileProperties->window), 440, 400);
   gtk_window_set_policy(GTK_WINDOW(gfrFileProperties->window), TRUE, TRUE, FALSE);
   
   dialog_vbox1 = GNOME_DIALOG(gfrFileProperties->window)->vbox;
   gtk_object_set_data(GTK_OBJECT(gfrFileProperties->window), "dialog_vbox1", dialog_vbox1);
   gtk_widget_show(dialog_vbox1);
   
   notebookProperties = gtk_notebook_new();
   gtk_widget_ref(notebookProperties);
   gtk_object_set_data_full(GTK_OBJECT(gfrFileProperties->window), "notebookProperties", notebookProperties,(GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show(notebookProperties);
   gtk_box_pack_start (GTK_BOX (dialog_vbox1), notebookProperties, TRUE, TRUE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (notebookProperties), 2);
   
   vbox2 = gtk_vbox_new(FALSE, 0);
   gtk_widget_ref(vbox2);
   gtk_object_set_data_full(GTK_OBJECT (gfrFileProperties->window), "vbox2", vbox2,(GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show(vbox2);
   gtk_container_add(GTK_CONTAINER (notebookProperties), vbox2);
   
   frameObjectInfo = gtk_frame_new(_("Object Information"));
   gtk_widget_ref(frameObjectInfo);
   gtk_object_set_data_full(GTK_OBJECT(gfrFileProperties->window), "frameObjectInfo", frameObjectInfo,(GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show(frameObjectInfo);
   gtk_box_pack_start(GTK_BOX(vbox2), frameObjectInfo, TRUE, TRUE, 0);
   gtk_container_set_border_width(GTK_CONTAINER (frameObjectInfo), 4);

   tableObjectInformation = gtk_table_new(3, 2, FALSE);
   gtk_widget_ref(tableObjectInformation);
   gtk_object_set_data_full(GTK_OBJECT(gfrFileProperties->window), "tableObjectInformation", tableObjectInformation,(GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show(tableObjectInformation);
   gtk_container_add(GTK_CONTAINER(frameObjectInfo), tableObjectInformation);

//TODO:  This should be "insensitive" (disabled) if there are more than one mime type in the list
   gfrFileProperties->iconentry = gnome_icon_entry_new(NULL, _("Choose a new icon for this file type"));
   gnome_icon_entry_set_icon(GNOME_ICON_ENTRY(gfrFileProperties->iconentry),gnome_vfs_icon_path_from_filename(gnome_vfs_mime_get_icon(file_list->mime_type)));
   gtk_widget_ref(gfrFileProperties->iconentry);
   gtk_object_set_data_full(GTK_OBJECT(gfrFileProperties->window), "iconentry", gfrFileProperties->iconentry,(GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show(gfrFileProperties->iconentry);
   gtk_table_attach(GTK_TABLE(tableObjectInformation), gfrFileProperties->iconentry, 0, 1, 0, 1,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
   gtk_container_set_border_width(GTK_CONTAINER(gfrFileProperties->iconentry), 1);

	if((file_list->flags&GNOME_VFS_FILE_FLAGS_SYMLINK)&&(file_list->type&GNOME_VFS_FILE_TYPE_DIRECTORY)){
		lblFileNames = gtk_label_new(_("Symbolic Directory Name(s):"));
	}else if(file_list->flags&GNOME_VFS_FILE_FLAGS_SYMLINK){
		lblFileNames = gtk_label_new(_("Symbolic File Name(s):"));
	}else if(file_list->type&GNOME_VFS_FILE_TYPE_DIRECTORY){
		lblFileNames = gtk_label_new(_("Directory Name(s):"));
	}else{
		lblFileNames = gtk_label_new(_("File Name(s):"));
	}
	gtk_widget_ref(lblFileNames);
	gtk_object_set_data_full(GTK_OBJECT(gfrFileProperties->window), "lblFileNames", lblFileNames,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(lblFileNames);
	gtk_table_attach(GTK_TABLE(tableObjectInformation), lblFileNames, 0, 1, 1, 2,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment(GTK_MISC (lblFileNames), 0, 0.5);
	gtk_misc_set_padding(GTK_MISC (lblFileNames), 10, 2);

	if(file_list->type&GNOME_VFS_FILE_TYPE_DIRECTORY){
		lblTotalSize = gtk_label_new(_("Directory Contents Size:"));
	}else{
		lblTotalSize = gtk_label_new(_("Total Size:"));
	}
	gtk_widget_ref(lblTotalSize);
	gtk_object_set_data_full(GTK_OBJECT (gfrFileProperties->window), "lblTotalSize", lblTotalSize,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(lblTotalSize);
	gtk_table_attach(GTK_TABLE (tableObjectInformation), lblTotalSize, 0, 1, 2, 3,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment(GTK_MISC (lblTotalSize), 0, 0.5);
	gtk_misc_set_padding(GTK_MISC (lblTotalSize), 10, 2);
	
	scrolledwin_txtFileName = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_ref (scrolledwin_txtFileName);
	gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "scrolledwin_txtFileName", scrolledwin_txtFileName,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (scrolledwin_txtFileName);
	gtk_table_attach (GTK_TABLE (tableObjectInformation), scrolledwin_txtFileName, 1, 2, 1, 2,(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),(GtkAttachOptions) (GTK_FILL), 0, 0);
	gtk_container_set_border_width (GTK_CONTAINER (scrolledwin_txtFileName), 4);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwin_txtFileName), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	
	viewport1 = gtk_viewport_new (NULL, NULL);
	gtk_widget_ref (viewport1);
	gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "viewport1", viewport1,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (viewport1);
	gtk_container_add (GTK_CONTAINER (scrolledwin_txtFileName), viewport1);

//FIXME:  Add namelist to the structure....this is probably another memory leak
	lstFileNames = gtk_list_new();
	gtk_widget_ref(lstFileNames);
	gtk_object_set_data_full(GTK_OBJECT(gfrFileProperties->window), "lstFileNames", lstFileNames,(GtkDestroyNotify)gtk_widget_unref);
	gtk_widget_show(lstFileNames);
	gtk_container_add(GTK_CONTAINER(viewport1), lstFileNames);
	gtk_list_set_selection_mode(GTK_LIST(lstFileNames), GTK_SELECTION_MULTIPLE);
	
	listitem=gtk_list_item_new_with_label(file_list->name);
	namelist=g_list_prepend(namelist,listitem);
	gtk_widget_show(listitem);
	gtk_object_set_data(GTK_OBJECT(listitem),"list_item_data","we can store data here");
	gtk_list_append_items(GTK_LIST(lstFileNames), namelist);

	if(file_list->type&GNOME_VFS_FILE_TYPE_DIRECTORY){
		txtTotalSize = gtk_label_new(_("--Not Implemented Yet--"));
	}else{
		//FIXME:  Possible memory leak....
		txtTotalSize = gtk_label_new(_(gnome_vfs_format_file_size_for_display(file_list->size)));
	}
	gtk_widget_ref(txtTotalSize);
	gtk_object_set_data_full(GTK_OBJECT (gfrFileProperties->window), "txtTotalSize", txtTotalSize,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(txtTotalSize);
	gtk_table_attach(GTK_TABLE (tableObjectInformation), txtTotalSize, 1, 2, 2, 3,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment(GTK_MISC (txtTotalSize), 0, 0.5);
	gtk_misc_set_padding(GTK_MISC (txtTotalSize), 4, 0);
	
	frameMIMEInfo = gtk_frame_new (_("MIME Information"));
	gtk_widget_ref (frameMIMEInfo);
	gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "frameMIMEInfo", frameMIMEInfo,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (frameMIMEInfo);
	gtk_box_pack_start (GTK_BOX (vbox2), frameMIMEInfo, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (frameMIMEInfo), 4);
	
	tableMIMEInfo = gtk_table_new (2, 2, FALSE);
	gtk_widget_ref (tableMIMEInfo);
	gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "tableMIMEInfo", tableMIMEInfo,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (tableMIMEInfo);
	gtk_container_add (GTK_CONTAINER (frameMIMEInfo), tableMIMEInfo);
	
	lblMIMEType = gtk_label_new (_("MIME Type:"));
	gtk_widget_ref (lblMIMEType);
	gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblMIMEType", lblMIMEType,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (lblMIMEType);
	gtk_table_attach (GTK_TABLE (tableMIMEInfo), lblMIMEType, 0, 1, 0, 1,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (lblMIMEType), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (lblMIMEType), 10, 2);
	
	lblDefaultApp = gtk_label_new (_("Default Application:"));
	gtk_widget_ref (lblDefaultApp);
	gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblDefaultApp", lblDefaultApp,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (lblDefaultApp);
	gtk_table_attach (GTK_TABLE (tableMIMEInfo), lblDefaultApp, 0, 1, 1, 2,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (lblDefaultApp), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (lblDefaultApp), 10, 2);
	
	txtMIMEType = gtk_label_new(_(file_list->mime_type));
	gtk_widget_ref (txtMIMEType);
	gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "txtMIMEType", txtMIMEType,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (txtMIMEType);
	gtk_table_attach (GTK_TABLE (tableMIMEInfo), txtMIMEType, 1, 2, 0, 1,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	gtk_misc_set_alignment (GTK_MISC (txtMIMEType), 0, 0.5);
	gtk_misc_set_padding (GTK_MISC (txtMIMEType), 4, 0);
	
	hbox1 = gtk_hbox_new (FALSE, 0);
	gtk_widget_ref (hbox1);
	gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "hbox1", hbox1,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hbox1);
	gtk_table_attach (GTK_TABLE (tableMIMEInfo), hbox1, 1, 2, 1, 2,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (GTK_FILL), 0, 0);

	vfsmimeapp=gnome_vfs_mime_get_default_application(file_list->mime_type);
   if(vfsmimeapp){
      if(vfsmimeapp->name){
         txtDefaultApp = gtk_label_new(_(vfsmimeapp->name));
      }
   }
   if(!txtDefaultApp)txtDefaultApp = gtk_label_new(_("None"));
	 gtk_widget_ref (txtDefaultApp);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "txtDefaultApp", txtDefaultApp,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (txtDefaultApp);
	 gtk_box_pack_start (GTK_BOX (hbox1), txtDefaultApp, FALSE, FALSE, 0);
	 gtk_misc_set_alignment (GTK_MISC (txtDefaultApp), 0, 0.5);
	 gtk_misc_set_padding (GTK_MISC (txtDefaultApp), 4, 0);
	 
	 btnModify = gtk_button_new_with_label (_("Modify"));
	 gtk_widget_ref(btnModify);
	 gtk_object_set_data_full(GTK_OBJECT(gfrFileProperties->window), "btnModify", btnModify,(GtkDestroyNotify)gtk_widget_unref);
	 gtk_widget_show(btnModify);
	 gtk_box_pack_start(GTK_BOX(hbox1), btnModify, FALSE, FALSE, 0);
	 gtk_container_set_border_width(GTK_CONTAINER(btnModify), 4);
	 gtk_tooltips_set_tip(tooltips, btnModify, _("Modify GNOME's Default Application for this File Type"), NULL);
	 
	 tablblGeneral = gtk_label_new(_("General"));
	 gtk_widget_ref (tablblGeneral);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "tablblGeneral", tablblGeneral,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (tablblGeneral);
	 gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebookProperties), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebookProperties), 0), tablblGeneral);
	 
	 tablePermissions = gtk_table_new (8, 4, TRUE);
	 gtk_widget_ref (tablePermissions);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "tablePermissions", tablePermissions,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (tablePermissions);
	 gtk_container_add (GTK_CONTAINER (notebookProperties), tablePermissions);
	 gtk_container_set_border_width (GTK_CONTAINER (tablePermissions), 8);
	 
	 lblPermW = gtk_label_new (_("Write"));
	 gtk_widget_ref (lblPermW);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblPermW", lblPermW,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (lblPermW);
	 gtk_table_attach (GTK_TABLE (tablePermissions), lblPermW, 2, 3, 0, 1,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_misc_set_alignment (GTK_MISC (lblPermW), 0, 0.5);
	 
	 lblPermX = gtk_label_new (_("Executable"));
	 gtk_widget_ref (lblPermX);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblPermX", lblPermX,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (lblPermX);
	 gtk_table_attach (GTK_TABLE (tablePermissions), lblPermX, 3, 4, 0, 1,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_misc_set_alignment (GTK_MISC (lblPermX), 0, 0.5);
	 
	 lblNobody = gtk_label_new (_("Nobody"));
	 gtk_widget_ref (lblNobody);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblNobody", lblNobody,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (lblNobody);
	 gtk_table_attach (GTK_TABLE (tablePermissions), lblNobody, 0, 1, 1, 2,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_misc_set_alignment (GTK_MISC (lblNobody), 0, 0.5);
	 gtk_misc_set_padding (GTK_MISC (lblNobody), 0, 8);
	 
	 lblOwner = gtk_label_new (_("Owner"));
	 gtk_widget_ref (lblOwner);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblOwner", lblOwner,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (lblOwner);
	 gtk_table_attach (GTK_TABLE (tablePermissions), lblOwner, 0, 1, 2, 3,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_misc_set_alignment (GTK_MISC (lblOwner), 0, 0.5);
	 gtk_misc_set_padding (GTK_MISC (lblOwner), 0, 8);
	 
	 lblGroup = gtk_label_new (_("Group"));
	 gtk_widget_ref (lblGroup);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblGroup", lblGroup,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (lblGroup);
	 gtk_table_attach (GTK_TABLE (tablePermissions), lblGroup, 0, 1, 3, 4,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_misc_set_alignment (GTK_MISC (lblGroup), 0, 0.5);
	 gtk_misc_set_padding (GTK_MISC (lblGroup), 0, 8);
	 
	 lblOther = gtk_label_new (_("Other"));
	 gtk_widget_ref (lblOther);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblOther", lblOther,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (lblOther);
	 gtk_table_attach (GTK_TABLE (tablePermissions), lblOther, 0, 1, 4, 5,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_misc_set_alignment (GTK_MISC (lblOther), 0, 0.5);
	 gtk_misc_set_padding (GTK_MISC (lblOther), 0, 8);
	 
	 lblPermR = gtk_label_new (_("Read"));
	 gtk_widget_ref (lblPermR);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblPermR", lblPermR,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (lblPermR);
	 gtk_table_attach (GTK_TABLE (tablePermissions), lblPermR, 1, 2, 0, 1,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_misc_set_alignment (GTK_MISC (lblPermR), 0, 0.5);
	 gtk_misc_set_padding (GTK_MISC (lblPermR), 4, 2);
	 
	 chkNobodyR = gtk_check_button_new();
	 gtk_widget_ref (chkNobodyR);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkNobodyR", chkNobodyR,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkNobodyR);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkNobodyR, 1, 2, 1, 2,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkNobodyR), 2);
	 gtk_tooltips_set_tip (tooltips, chkNobodyR, _("Deny everyone Read access"), NULL);
	 
	 chkNobodyW = gtk_check_button_new();
	 gtk_widget_ref (chkNobodyW);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkNobodyW", chkNobodyW,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkNobodyW);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkNobodyW, 2, 3, 1, 2,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkNobodyW), 2);
	 gtk_tooltips_set_tip (tooltips, chkNobodyW, _("Deny everyone Write access"), NULL);
	 
	 chkNobodyX = gtk_check_button_new();
	 gtk_widget_ref (chkNobodyX);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkNobodyX", chkNobodyX,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkNobodyX);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkNobodyX, 3, 4, 1, 2,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkNobodyX), 2);
	 gtk_tooltips_set_tip (tooltips, chkNobodyX, _("Deny everyone Execution rights"), NULL);
	 
	 chkOwnerR = gtk_check_button_new();
	 gtk_widget_ref (chkOwnerR);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkOwnerR", chkOwnerR,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkOwnerR);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkOwnerR, 1, 2, 2, 3,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkOwnerR), 2);
	 
	 chkOwnerW = gtk_check_button_new();
	 gtk_widget_ref (chkOwnerW);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkOwnerW", chkOwnerW,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkOwnerW);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkOwnerW, 2, 3, 2, 3,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkOwnerW), 2);
	 
	 chkOwnerX = gtk_check_button_new();
	 gtk_widget_ref (chkOwnerX);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkOwnerX", chkOwnerX,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkOwnerX);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkOwnerX, 3, 4, 2, 3,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkOwnerX), 2);
	 
	 chkGroupR = gtk_check_button_new();
	 gtk_widget_ref (chkGroupR);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkGroupR", chkGroupR,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkGroupR);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkGroupR, 1, 2, 3, 4,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkGroupR), 2);
	 
	 chkGroupW = gtk_check_button_new();
	 gtk_widget_ref (chkGroupW);
	 gtk_object_set_data_full (GTK_OBJECT(gfrFileProperties->window), "chkGroupW", chkGroupW,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkGroupW);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkGroupW, 2, 3, 3, 4,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkGroupW), 2);
	 
	 chkGroupX = gtk_check_button_new();
	 gtk_widget_ref (chkGroupX);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkGroupX", chkGroupX,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkGroupX);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkGroupX, 3, 4, 3, 4,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkGroupX), 2);
	 
	 chkOtherR = gtk_check_button_new();
	 gtk_widget_ref (chkOtherR);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkOtherR", chkOtherR,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkOtherR);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkOtherR, 1, 2, 4, 5,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkOtherR), 2);
	 
	 chkOtherW = gtk_check_button_new();
	 gtk_widget_ref (chkOtherW);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkOtherW", chkOtherW,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkOtherW);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkOtherW, 2, 3, 4, 5,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkOtherW), 2);
	 
	 chkOtherX = gtk_check_button_new();
	 gtk_widget_ref (chkOtherX);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkOtherX", chkOtherX,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkOtherX);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkOtherX, 3, 4, 4, 5,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkOtherX), 2);

	 lblEveryone = gtk_label_new (_("Everyone"));
	 gtk_widget_ref (lblEveryone);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblEveryone", lblEveryone,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (lblEveryone);
	 gtk_table_attach (GTK_TABLE (tablePermissions), lblEveryone, 0, 1, 5, 6,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_misc_set_alignment (GTK_MISC (lblEveryone), 0, 0.5);
	 gtk_misc_set_padding (GTK_MISC (lblEveryone), 0, 8);
	 
	 chkEveryoneR = gtk_check_button_new();
	 gtk_widget_ref (chkEveryoneR);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkEveryoneR", chkEveryoneR,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkEveryoneR);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkEveryoneR, 1, 2, 5, 6,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkEveryoneR), 2);
	 gtk_tooltips_set_tip (tooltips, chkEveryoneR, _("Allow everyone Read access"), NULL);
	 
	 chkEveryoneW = gtk_check_button_new();
	 gtk_widget_ref (chkEveryoneW);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkEveryoneW", chkEveryoneW,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkEveryoneW);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkEveryoneW, 2, 3, 5, 6,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkEveryoneW), 2);
	 gtk_tooltips_set_tip (tooltips, chkEveryoneW, _("Allow everyone Write access"), NULL);
	 
	 chkEveryoneX = gtk_check_button_new();
	 gtk_widget_ref (chkEveryoneX);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkEveryoneX", chkEveryoneX,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkEveryoneX);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkEveryoneX, 3, 4, 5, 6,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkEveryoneX), 2);
	 gtk_tooltips_set_tip (tooltips, chkEveryoneX, _("Allow everyone Execution rights"), NULL);
	 
	 lblSpecial = gtk_label_new(_("Special"));
	 gtk_widget_ref(lblSpecial);
	 gtk_object_set_data_full(GTK_OBJECT (gfrFileProperties->window), "lblSpecial", lblSpecial,(GtkDestroyNotify)gtk_widget_unref);
	 gtk_widget_show(lblSpecial);
	 gtk_table_attach(GTK_TABLE(tablePermissions), lblSpecial, 0, 1, 6, 7,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_label_set_justify(GTK_LABEL(lblSpecial), GTK_JUSTIFY_LEFT);
	 gtk_misc_set_alignment(GTK_MISC(lblSpecial), 0, 0.5);
	 gtk_misc_set_padding(GTK_MISC(lblSpecial), 0, 5);

	 chkSUID = gtk_check_button_new_with_label (_("SUID"));
	 gtk_widget_ref (chkSUID);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkSUID", chkSUID,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkSUID);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkSUID, 1, 2, 6, 7,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkSUID), 2);
	 gtk_tooltips_set_tip (tooltips, chkSUID, _("Set SUID bit"), NULL);
	 gtk_toggle_button_set_mode (GTK_TOGGLE_BUTTON (chkSUID), FALSE);
	 
	 chkSGID = gtk_check_button_new_with_label (_("SGID"));
	 gtk_widget_ref (chkSGID);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkSGID", chkSGID,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkSGID);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkSGID, 2, 3, 6, 7,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkSGID), 2);
	 gtk_tooltips_set_tip (tooltips, chkSGID, _("Set SGID bit"), NULL);
	 gtk_toggle_button_set_mode (GTK_TOGGLE_BUTTON (chkSGID), FALSE);
	 
	 chkSticky = gtk_check_button_new_with_label (_("Sticky"));
	 gtk_widget_ref (chkSticky);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "chkSticky", chkSticky,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (chkSticky);
	 gtk_table_attach (GTK_TABLE (tablePermissions), chkSticky, 3, 4, 6, 7,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
	 gtk_container_set_border_width (GTK_CONTAINER (chkSticky), 2);
	 gtk_tooltips_set_tip (tooltips, chkSticky, _("Set Sticky bit"), NULL);
	 gtk_toggle_button_set_mode (GTK_TOGGLE_BUTTON (chkSticky), FALSE);

lblFileOwner = gtk_label_new (_("File Owner:"));
gtk_widget_ref (lblFileOwner);
gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblFileOwner", lblFileOwner,(GtkDestroyNotify) gtk_widget_unref);
gtk_widget_show (lblFileOwner);
gtk_table_attach (GTK_TABLE (tablePermissions), lblFileOwner, 0, 1, 7, 8,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);
gtk_misc_set_padding (GTK_MISC (lblFileOwner), 0, 8);

lblFileGroup = gtk_label_new (_("File Group:"));
gtk_widget_ref (lblFileGroup);
gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "lblFileGroup", lblFileGroup,(GtkDestroyNotify) gtk_widget_unref);
gtk_widget_show (lblFileGroup);
gtk_table_attach (GTK_TABLE (tablePermissions), lblFileGroup, 2, 3, 7, 8,(GtkAttachOptions) (GTK_FILL),(GtkAttachOptions) (0), 0, 0);

cboFileOwner = gtk_combo_new ();
gtk_widget_ref (cboFileOwner);
gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "cboFileOwner", cboFileOwner,(GtkDestroyNotify) gtk_widget_unref);
gtk_widget_show (cboFileOwner);
gtk_table_attach (GTK_TABLE (tablePermissions), cboFileOwner, 1, 2, 7, 8,(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),(GtkAttachOptions) (0), 0, 0);
gtk_container_set_border_width (GTK_CONTAINER (cboFileOwner), 2);

cboFileOwner_Entry = GTK_COMBO (cboFileOwner)->entry;
gtk_widget_ref (cboFileOwner_Entry);
gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "cboFileOwner_Entry", cboFileOwner_Entry,(GtkDestroyNotify) gtk_widget_unref);
gtk_widget_show (cboFileOwner_Entry);
{
	GList*list=NULL;
	char*selection=NULL;
	struct passwd*pwent=getpwent();
	while(pwent){
		list=g_list_append(list,(gpointer)g_strdup(pwent->pw_name));
		if(pwent->pw_uid==file_list->uid) selection=g_strdup(pwent->pw_name);
		pwent=getpwent();
	}
	endpwent();
	gtk_combo_set_popdown_strings(GTK_COMBO(cboFileOwner),list);
	while(list){
		g_free((char*)list->data);
		list=list->next;
	}
	g_list_free(list);
	gtk_entry_set_text(GTK_ENTRY(cboFileOwner_Entry),selection);
	g_free(selection);
}

cboFileGroup = gtk_combo_new ();
gtk_widget_ref (cboFileGroup);
gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "cboFileGroup", cboFileGroup,(GtkDestroyNotify) gtk_widget_unref);
gtk_widget_show (cboFileGroup);
gtk_table_attach (GTK_TABLE (tablePermissions), cboFileGroup, 3, 4, 7, 8,(GtkAttachOptions) (GTK_EXPAND | GTK_FILL),(GtkAttachOptions) (0), 0, 0);
gtk_container_set_border_width (GTK_CONTAINER (cboFileGroup), 2);

cboFileGroup_Entry = GTK_COMBO (cboFileGroup)->entry;
gtk_widget_ref (cboFileGroup_Entry);
gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "cboFileGroup_Entry", cboFileGroup_Entry,(GtkDestroyNotify) gtk_widget_unref);
gtk_widget_show (cboFileGroup_Entry);
{
	GList*list=NULL;
	char*selection=NULL;
	struct group*grent=getgrent();
	while(grent){
		list=g_list_append(list,(gpointer)g_strdup(grent->gr_name));
		if(grent->gr_gid==file_list->gid) selection=g_strdup(grent->gr_name);
		grent=getgrent();
	}
	endgrent();
	gtk_combo_set_popdown_strings(GTK_COMBO(cboFileGroup),list);
	while(list){
		g_free((char*)list->data);
		list=list->next;
	}
	g_list_free(list);
	gtk_entry_set_text(GTK_ENTRY(cboFileGroup_Entry),selection);
	g_free(selection);
}

	 tablblPermissions = gtk_label_new (_("Permissions"));
	 gtk_widget_ref (tablblPermissions);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "tablblPermissions", tablblPermissions,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (tablblPermissions);
	 gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebookProperties), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebookProperties), 1), tablblPermissions);
	 
	 dialog_action_area1 = GNOME_DIALOG (gfrFileProperties->window)->action_area;
	 gtk_object_set_data (GTK_OBJECT (gfrFileProperties->window), "dialog_action_area1", dialog_action_area1);
	 gtk_widget_show (dialog_action_area1);
	 gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
	 gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);
	 
	 gnome_dialog_append_button (GNOME_DIALOG (gfrFileProperties->window), GNOME_STOCK_BUTTON_HELP);
	 btnHelp = GTK_WIDGET (g_list_last (GNOME_DIALOG (gfrFileProperties->window)->buttons)->data);
	 gtk_widget_ref (btnHelp);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "btnHelp", btnHelp,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (btnHelp);
	 GTK_WIDGET_SET_FLAGS (btnHelp, GTK_CAN_DEFAULT);
	 
	 gnome_dialog_append_button (GNOME_DIALOG (gfrFileProperties->window), GNOME_STOCK_BUTTON_OK);
	 btnOk = GTK_WIDGET (g_list_last (GNOME_DIALOG (gfrFileProperties->window)->buttons)->data);
	 gtk_widget_ref (btnOk);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "btnOk", btnOk,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (btnOk);
	 GTK_WIDGET_SET_FLAGS (btnOk, GTK_CAN_DEFAULT);
	 
	 gnome_dialog_append_button (GNOME_DIALOG (gfrFileProperties->window), GNOME_STOCK_BUTTON_CANCEL);
	 btnCancel = GTK_WIDGET (g_list_last (GNOME_DIALOG (gfrFileProperties->window)->buttons)->data);
	 gtk_widget_ref (btnCancel);
	 gtk_object_set_data_full (GTK_OBJECT (gfrFileProperties->window), "btnCancel", btnCancel,(GtkDestroyNotify) gtk_widget_unref);
	 gtk_widget_show (btnCancel);
	 GTK_WIDGET_SET_FLAGS (btnCancel, GTK_CAN_DEFAULT);

//TODO:  For multiple files this will need to be a GList???
//TODO:  Do this up top so that you don't have to do it this here.....lotsa code redoin.....
	 gfrFileProperties->permissions=new_permission_btns();
	 gfrFileProperties->permissions->Nobody[PERM_READ]=GTK_TOGGLE_BUTTON(chkNobodyR);
	 gfrFileProperties->permissions->Nobody[PERM_WRITE]=GTK_TOGGLE_BUTTON(chkNobodyW);
	 gfrFileProperties->permissions->Nobody[PERM_EXECUTE]=GTK_TOGGLE_BUTTON(chkNobodyX);
	 gfrFileProperties->permissions->Owner[PERM_READ]=GTK_TOGGLE_BUTTON(chkOwnerR);
	 gfrFileProperties->permissions->Owner[PERM_WRITE]=GTK_TOGGLE_BUTTON(chkOwnerW);
	 gfrFileProperties->permissions->Owner[PERM_EXECUTE]=GTK_TOGGLE_BUTTON(chkOwnerX);
	 gfrFileProperties->permissions->Group[PERM_READ]=GTK_TOGGLE_BUTTON(chkGroupR);
	 gfrFileProperties->permissions->Group[PERM_WRITE]=GTK_TOGGLE_BUTTON(chkGroupW);
	 gfrFileProperties->permissions->Group[PERM_EXECUTE]=GTK_TOGGLE_BUTTON(chkGroupX);
	 gfrFileProperties->permissions->Other[PERM_READ]=GTK_TOGGLE_BUTTON(chkOtherR);
	 gfrFileProperties->permissions->Other[PERM_WRITE]=GTK_TOGGLE_BUTTON(chkOtherW);
	 gfrFileProperties->permissions->Other[PERM_EXECUTE]=GTK_TOGGLE_BUTTON(chkOtherX);
	 gfrFileProperties->permissions->Everyone[PERM_READ]=GTK_TOGGLE_BUTTON(chkEveryoneR);
	 gfrFileProperties->permissions->Everyone[PERM_WRITE]=GTK_TOGGLE_BUTTON(chkEveryoneW);
	 gfrFileProperties->permissions->Everyone[PERM_EXECUTE]=GTK_TOGGLE_BUTTON(chkEveryoneX);

/*
	GNOME_VFS_PERM_SUID = S_ISUID,
	GNOME_VFS_PERM_SGID = S_ISGID,	
	GNOME_VFS_PERM_STICKY = 01000,
	GNOME_VFS_PERM_USER_READ = S_IRUSR,
	GNOME_VFS_PERM_USER_WRITE = S_IWUSR,
	GNOME_VFS_PERM_USER_EXEC = S_IXUSR,
	GNOME_VFS_PERM_USER_ALL = S_IRUSR | S_IWUSR | S_IXUSR,
	GNOME_VFS_PERM_GROUP_READ = S_IRGRP,
	GNOME_VFS_PERM_GROUP_WRITE = S_IWGRP,
	GNOME_VFS_PERM_GROUP_EXEC = S_IXGRP,
	GNOME_VFS_PERM_GROUP_ALL = S_IRGRP | S_IWGRP | S_IXGRP,
	GNOME_VFS_PERM_OTHER_READ = S_IROTH,
	GNOME_VFS_PERM_OTHER_WRITE = S_IWOTH,
	GNOME_VFS_PERM_OTHER_EXEC = S_IXOTH,
	GNOME_VFS_PERM_OTHER_ALL = S_IROTH | S_IWOTH | S_IXOTH
*/


//Set buttons to show permissions properly
	 if(file_list->permissions&GNOME_VFS_PERM_USER_READ)
		  gtk_toggle_button_set_active(gfrFileProperties->permissions->Owner[PERM_READ],TRUE);
	 if(file_list->permissions&GNOME_VFS_PERM_GROUP_READ)
		  gtk_toggle_button_set_active(gfrFileProperties->permissions->Group[PERM_READ],TRUE);
	 if(file_list->permissions&GNOME_VFS_PERM_OTHER_READ)
		  gtk_toggle_button_set_active(gfrFileProperties->permissions->Other[PERM_READ],TRUE);

	 if(file_list->permissions&GNOME_VFS_PERM_USER_WRITE)
		  gtk_toggle_button_set_active(gfrFileProperties->permissions->Owner[PERM_WRITE],TRUE);
	 if(file_list->permissions&GNOME_VFS_PERM_GROUP_WRITE)
		  gtk_toggle_button_set_active(gfrFileProperties->permissions->Group[PERM_WRITE],TRUE);
	 if(file_list->permissions&GNOME_VFS_PERM_OTHER_WRITE)
		  gtk_toggle_button_set_active(gfrFileProperties->permissions->Other[PERM_WRITE],TRUE);

	 if(file_list->permissions&GNOME_VFS_PERM_USER_EXEC)
		  gtk_toggle_button_set_active(gfrFileProperties->permissions->Owner[PERM_EXECUTE],TRUE);
	 if(file_list->permissions&GNOME_VFS_PERM_GROUP_EXEC)
		  gtk_toggle_button_set_active(gfrFileProperties->permissions->Group[PERM_EXECUTE],TRUE);
	 if(file_list->permissions&GNOME_VFS_PERM_OTHER_EXEC)
		  gtk_toggle_button_set_active(gfrFileProperties->permissions->Other[PERM_EXECUTE],TRUE);

	 if(file_list->permissions&GNOME_VFS_PERM_SUID) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chkSUID),TRUE);
	 if(file_list->permissions&GNOME_VFS_PERM_SGID) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chkSGID),TRUE);
	 if(file_list->permissions&GNOME_VFS_PERM_STICKY) gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chkSticky),TRUE);
	 
	 gtk_signal_connect(GTK_OBJECT(chkNobodyR), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkNobodyR_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkNobodyR), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkNobodyR_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkNobodyW), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkNobodyW_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkNobodyX), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkNobodyX_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkOwnerR), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkOwnerR_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkOwnerW), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkOwnerW_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkOwnerX), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkOwnerX_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkGroupR), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkGroupR_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkGroupW), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkGroupW_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkGroupX), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkGroupX_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkOtherR), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkOtherR_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkOtherW), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkOtherW_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkOtherX), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkOtherX_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkEveryoneR), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkEveryoneR_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkEveryoneW), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkEveryoneW_toggled),(gpointer)gfrFileProperties->permissions);
	 gtk_signal_connect(GTK_OBJECT(chkEveryoneX), "toggled",GTK_SIGNAL_FUNC(dlgFileProperties_on_chkEveryoneX_toggled),(gpointer)gfrFileProperties->permissions);
/*  TODO:  Activate all signals....
	 gtk_signal_connect(GTK_OBJECT (notebookProperties), "switch_page",GTK_SIGNAL_FUNC(dlgFileProperties_on_notebookProperties_switch_page),NULL);
	 gtk_signal_connect(GTK_OBJECT (lstFileNames), "selection_changed",GTK_SIGNAL_FUNC(dlgFileProperties_on_lstFileNames_selection_changed),NULL);
	 gtk_signal_connect(GTK_OBJECT (btnHelp), "clicked",GTK_SIGNAL_FUNC(dlgFileProperties_on_btnHelp_clicked),NULL);
*/
	 gtk_signal_connect(GTK_OBJECT (btnModify), "clicked",GTK_SIGNAL_FUNC(dlgFileProperties_on_btnModify_clicked),(gpointer)file_list->mime_type);
	 gtk_signal_connect(GTK_OBJECT(btnOk), "clicked",GTK_SIGNAL_FUNC(dlgFileProperties_on_btnOk_clicked),(gpointer)gfrFileProperties);
	 gtk_signal_connect(GTK_OBJECT(btnCancel), "clicked",GTK_SIGNAL_FUNC(dlgFileProperties_on_btnCancel_clicked),(gpointer)gfrFileProperties);

	 gtk_object_set_data (GTK_OBJECT(gfrFileProperties->window), "tooltips", tooltips);
	 gtk_widget_show(gfrFileProperties->window);
	 return gfrFileProperties->window;
}

void free_gfilerunner_file_properties(gfilerunner_file_properties*gfr_props){
	 free_permission_btns(gfr_props->permissions);
	 gtk_widget_destroy(GTK_WIDGET(gfr_props->window));
	 g_free(gfr_props);
}

//Nobody Permissions
void dlgFileProperties_on_chkNobodyR_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Owner[PERM_READ],FALSE);
		  gtk_toggle_button_set_active(permissions->Group[PERM_READ],FALSE);
		  gtk_toggle_button_set_active(permissions->Other[PERM_READ],FALSE);
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}
void dlgFileProperties_on_chkNobodyW_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Owner[PERM_WRITE],FALSE);
		  gtk_toggle_button_set_active(permissions->Group[PERM_WRITE],FALSE);
		  gtk_toggle_button_set_active(permissions->Other[PERM_WRITE],FALSE);
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_WRITE],FALSE);
	 }
}
void dlgFileProperties_on_chkNobodyX_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Owner[PERM_EXECUTE],FALSE);
		  gtk_toggle_button_set_active(permissions->Group[PERM_EXECUTE],FALSE);
		  gtk_toggle_button_set_active(permissions->Other[PERM_EXECUTE],FALSE);
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_EXECUTE],FALSE);
	 }
}

//Owner Permissions
void dlgFileProperties_on_chkOwnerR_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_READ],FALSE);
	 }else{
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}
void dlgFileProperties_on_chkOwnerW_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_WRITE],FALSE);
	 }else{
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}
void dlgFileProperties_on_chkOwnerX_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_EXECUTE],FALSE);
	 }else{
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}

//Group Permissions
void dlgFileProperties_on_chkGroupR_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_READ],FALSE);
	 }else{
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}
void dlgFileProperties_on_chkGroupW_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_WRITE],FALSE);
	 }else{
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}
void dlgFileProperties_on_chkGroupX_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_EXECUTE],FALSE);
	 }else{
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}

//Other Permissions
void dlgFileProperties_on_chkOtherR_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_READ],FALSE);
	 }else{
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}
void dlgFileProperties_on_chkOtherW_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_WRITE],FALSE);
	 }else{
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}
void dlgFileProperties_on_chkOtherX_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_EXECUTE],FALSE);
	 }else{
		  gtk_toggle_button_set_active(permissions->Everyone[PERM_READ],FALSE);
	 }
}

//Everyone Permissions
void dlgFileProperties_on_chkEveryoneR_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_READ],FALSE);
		  gtk_toggle_button_set_active(permissions->Owner[PERM_READ],TRUE);
		  gtk_toggle_button_set_active(permissions->Group[PERM_READ],TRUE);
		  gtk_toggle_button_set_active(permissions->Other[PERM_READ],TRUE);
	 }
}
void dlgFileProperties_on_chkEveryoneW_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_WRITE],FALSE);
		  gtk_toggle_button_set_active(permissions->Owner[PERM_WRITE],TRUE);
		  gtk_toggle_button_set_active(permissions->Group[PERM_WRITE],TRUE);
		  gtk_toggle_button_set_active(permissions->Other[PERM_WRITE],TRUE);
	 }
}
void dlgFileProperties_on_chkEveryoneX_toggled(GtkToggleButton *togglebutton,gpointer user_data){
	 permission_btns* permissions=(permission_btns*)user_data;
	 if(gtk_toggle_button_get_active(togglebutton)){
		  gtk_toggle_button_set_active(permissions->Nobody[PERM_EXECUTE],FALSE);
		  gtk_toggle_button_set_active(permissions->Owner[PERM_EXECUTE],TRUE);
		  gtk_toggle_button_set_active(permissions->Group[PERM_EXECUTE],TRUE);
		  gtk_toggle_button_set_active(permissions->Other[PERM_EXECUTE],TRUE);
	 }
}

void dlgFileProperties_on_btnOk_clicked(GtkButton*button,gpointer user_data){
	gfilerunner_file_properties* gfr_props=(gfilerunner_file_properties*)user_data;
	char* origiconpath=gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(gfr_props->iconentry));
	char* iconpath=origiconpath;
	char* gnome_pixmap_path=gnome_unconditional_pixmap_file("");
	int len=strlen(gnome_pixmap_path);
	if(strncasecmp(origiconpath,gnome_pixmap_path,len)==0) iconpath+=len;
	gnome_vfs_mime_set_icon(gfr_props->file_list->mime_type,iconpath);
	//TODO:  Apply any changes here...
	free_gfilerunner_file_properties(gfr_props);
}

void dlgFileProperties_on_btnCancel_clicked(GtkButton*button,gpointer user_data){
	 gfilerunner_file_properties* gfr_props=(gfilerunner_file_properties*)user_data;
	 //TODO: ?? Discard changes here...
	 free_gfilerunner_file_properties(gfr_props);
}

void dlgFileProperties_on_btnModify_clicked(GtkButton*button,gpointer user_data){
  char* argstr=g_strdup_printf("%s %s &",FILE_TYPES_CAPPLET_NAME,(char*)user_data);
  system(argstr);
}
