//
//  GFileRunner include file
//  By Kyle Davis
//
//  This controls file property window related functions.
//
#ifndef GFILERUNNER_FILE_PROPERTIES_WINDOW_H
#define GFILERUNNER_FILE_PROPERTIES_WINDOW_H

#include <gnome.h>
#include <libgnomevfs/gnome-vfs.h>
#include <libgnomevfs/gnome-vfs-mime-handlers.h>

#include "gfilerunner-sys.h"

#define FILE_TYPES_CAPPLET_NAME         "file-types-capplet"

typedef enum {PERM_READ=0,PERM_WRITE,PERM_EXECUTE} gfilerunner_properties_window_permission;
typedef struct _permission_btns permission_btns;
struct _permission_btns{
	GtkToggleButton** Nobody;
	GtkToggleButton** Owner;
	GtkToggleButton** Group;
	GtkToggleButton** Other;
	GtkToggleButton** Everyone;
};

typedef struct _gfilerunner_file_properties gfilerunner_file_properties;
struct _gfilerunner_file_properties{
	GtkWidget *window;
	GtkWidget *iconentry;
//TODO:  This should be a GList of GnomeVFSFileInfo*s
	GnomeVFSFileInfo*file_list;
	permission_btns* permissions;
};

//Data type functions
permission_btns* new_permission_btns(void);
void free_permission_btns(permission_btns*);
void free_gfilerunner_file_properties(gfilerunner_file_properties*gfr_props);
		 
//TODO:  Main function
GtkWidget* show_dlgFileProperties(GnomeVFSFileInfo*);

//Callback functions
void dlgFileProperties_on_btnOk_clicked(GtkButton*,gpointer);
void dlgFileProperties_on_btnCancel_clicked(GtkButton*,gpointer);
void dlgFileProperties_on_btnModify_clicked(GtkButton*,gpointer);

//Nobody Permissions
void dlgFileProperties_on_chkNobodyR_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkNobodyW_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkNobodyX_toggled(GtkToggleButton*,gpointer);
//Owner Permissions
void dlgFileProperties_on_chkOwnerR_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkOwnerW_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkOwnerX_toggled(GtkToggleButton*,gpointer);
//Group Permissions
void dlgFileProperties_on_chkGroupR_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkGroupW_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkGroupX_toggled(GtkToggleButton*,gpointer);
//Other ppl's Permissions
void dlgFileProperties_on_chkOtherR_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkOtherW_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkOtherX_toggled(GtkToggleButton*,gpointer);
//Everyone Permissions
void dlgFileProperties_on_chkEveryoneR_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkEveryoneW_toggled(GtkToggleButton*,gpointer);
void dlgFileProperties_on_chkEveryoneX_toggled(GtkToggleButton*,gpointer);

#endif
