/*
*  GFileRunner		by Kyle Davis
*  
*  GFileRunner and all its pertaining source code is under the GNU General Public License.
*
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <capplet-widget.h>
#include <libgnomevfs/gnome-vfs.h>

#include "gfilerunner-preferences-capplet.h"

GtkWidget*rhs=NULL;
GtkWidget*hpaned=NULL;

int main(int argc, char**argv){
#ifdef ENABLE_NLS
	bindtextdomain(PACKAGE, PACKAGE_LOCALE_DIR);
	textdomain(PACKAGE);
#endif
	gnome_capplet_init("GFileRunner - Preferences",VERSION,argc,argv,NULL,0,NULL);
	gfilerunner_preferences_window_new();
	capplet_gtk_main();
	return(0);
}

GtkWidget*gfilerunner_preferences_window_new(){
	GtkWidget*scrolledwindow;
	GtkWidget*ctree;
	char*text[]={"","",NULL};
	GtkCTreeNode*ctree_newnode=NULL;
	GtkWidget*window=capplet_widget_new();
	gtk_widget_ref(window);
	gtk_object_set_data_full(GTK_OBJECT(window),"window",window,(GtkDestroyNotify)gtk_widget_unref);

        hpaned=gtk_hpaned_new();
        gtk_widget_ref(hpaned);
        gtk_object_set_data_full(GTK_OBJECT(window), "hpaned", hpaned,(GtkDestroyNotify)gtk_widget_unref);
        gtk_widget_show(hpaned);
	gtk_container_add(GTK_CONTAINER(window),hpaned);
        gtk_widget_set_usize(hpaned, 400, 300);
        gtk_paned_set_position(GTK_PANED(hpaned), 100);

        scrolledwindow=gtk_scrolled_window_new(NULL, NULL);
        gtk_widget_ref(scrolledwindow);
        gtk_object_set_data_full(GTK_OBJECT(window), "scrolledwindow", scrolledwindow,(GtkDestroyNotify)gtk_widget_unref);
        gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
        gtk_widget_show(scrolledwindow);
        gtk_paned_pack1(GTK_PANED(hpaned), scrolledwindow, FALSE, TRUE);

        ctree=gtk_ctree_new(1,0);
        gtk_ctree_set_line_style(GTK_CTREE(ctree),GTK_CTREE_LINES_SOLID);
        gtk_ctree_set_expander_style(GTK_CTREE(ctree),GTK_CTREE_EXPANDER_SQUARE);
        gtk_widget_ref(ctree);
        gtk_object_set_data_full(GTK_OBJECT(window), "ctree", ctree,(GtkDestroyNotify)gtk_widget_unref);
	gtk_widget_show(ctree);
	gtk_container_add(GTK_CONTAINER(scrolledwindow), ctree);

	text[0]="General";
	ctree_newnode=gtk_ctree_insert_node(GTK_CTREE(ctree),NULL,NULL,text,2,NULL,NULL,NULL,NULL,FALSE,TRUE);
	gtk_ctree_node_set_row_data(GTK_CTREE(ctree),GTK_CTREE_NODE(ctree_newnode),(gpointer)text[0]);
        text[0]="Themes";
	ctree_newnode=gtk_ctree_insert_node(GTK_CTREE(ctree),NULL,NULL,text,2,NULL,NULL,NULL,NULL,FALSE,TRUE);
	gtk_ctree_node_set_row_data(GTK_CTREE(ctree),GTK_CTREE_NODE(ctree_newnode),(gpointer)text[0]);

	gtk_signal_connect(GTK_OBJECT(ctree),"tree-select-row",GTK_SIGNAL_FUNC(on_ctree_row_select),NULL);

	gtk_widget_show(window);
	return(window);
}

void set_rhs(GtkWidget*widget){ /* nuke whatever rhs is, set it to widget, and reconnect to the hpaned */
	if(rhs){
		gtk_widget_destroy(rhs);
		rhs=NULL;
	}
	rhs=widget;
	gtk_paned_pack2(GTK_PANED(hpaned), rhs, FALSE, TRUE);
	gtk_widget_show(rhs); /* just in case */
}

void on_ctree_row_select(GtkCTree *ctree, GList *node, gint column, gpointer user_data){
        char*txt=(char*)gtk_ctree_node_get_row_data(GTK_CTREE(ctree),GTK_CTREE_NODE(node));
	if(strcmp(txt,"General")==0){
		GtkWidget*newrhs=gtk_label_new("General Settings");
		gtk_widget_ref(newrhs);
		gtk_object_set_data_full(GTK_OBJECT(hpaned),"rhs",newrhs,(GtkDestroyNotify)gtk_widget_unref);
		set_rhs(newrhs);
	}
	if(strcmp(txt,"Themes")==0){
		GtkWidget*newrhs=gtk_label_new("Theme Settings");
		gtk_widget_ref(newrhs);
		gtk_object_set_data_full(GTK_OBJECT(hpaned),"rhs",newrhs,(GtkDestroyNotify)gtk_widget_unref);
		set_rhs(newrhs);
	}
	fprintf(stderr,"clicked on %s\n",txt);
}

