#ifndef GFILERUNNER_PREFERENCES_H
#define GFILERUNNER_PREFERENCES_H

#include <glib.h>
#include "gfilerunner-theme-defs.h"
#include "gfilerunner-sys.h"
#include "gfilerunner-basic-icon-types.h"

typedef struct _gfilerunner_locations_preferences gfilerunner_locations_preferences;
struct _gfilerunner_locations_preferences{	//TODO:  use gnomevfsuri*'s here???
	char*home;
	char*trash;
	char*desktop;
	char*terminal;
};

typedef struct _gfilerunner_theme_preferences gfilerunner_theme_preferences;
struct _gfilerunner_theme_preferences{
	char*theme_prefix;	/* NOTE: default theme MUST be installed */
	GtkToolbarStyle toolbar_style;
	int toolbar_size;
};

typedef struct _gfilerunner_speed_preferences gfilerunner_speed_preferences;
struct _gfilerunner_speed_preferences{
	int speedloading_threshold;
	int resize_threshold;
};

typedef struct _gfilerunner_graphics_preferences gfilerunner_graphics_preferences;
struct _gfilerunner_graphics_preferences{
	gboolean handle_desktop; /*TODO:  the entire desktop.....*/
	gboolean canvas_aa;
	basic_icon_AnimationMode AniMode;

	gboolean load_images;		//ALL SIZES ARE IN KB
	gboolean load_animations;//TODO:  make these work....
	int max_animation_size;
	int max_image_size;
//	int cache_size;
//	int cache_to_disk_size;
};

typedef struct _gfilerunner_view_preferences gfilerunner_view_preferences;
struct _gfilerunner_view_preferences{
	gboolean directories_first;
	int mode;	//list, icon (etc.?)
	int arrange_by;	//no sorting, name, date, size, type, etc.
	gboolean l2r_t2b;  //drawing mode, left to right, or top to bottom...
};

typedef struct _gfilerunner_userfriendly_preferences gfilerunner_userfriendly_preferences;
struct _gfilerunner_userfriendly_preferences{
	gboolean keep_stats; //stats on which items in the dynamic menus (open with/scripts/plugin stuff) are used most.  used for reordering them by usage.
	gboolean sync_tree_with_location; //if gfilerunner_tree selection is changed when we go somewhere....
};

typedef struct _gfilerunner_trash_preferences gfilerunner_trash_preferences;
struct _gfilerunner_trash_preferences{
	gboolean trash_is_delete; //some people hate the trash idea....
	gboolean ask_before_trash;
};

typedef struct _gfilerunner_disk_usage_preferences gfilerunner_disk_usage_preferences; //memory usage too....
struct _gfilerunner_disk_usage_preferences{
	gboolean watch_mount_points;  /*allow for load and unload of things*/
	int max_trash_size;
	int min_free_space;
	int cache_size;
	int cache_to_disk_size;
};

typedef struct _gfilerunner_plugin_preferences gfilerunner_plugin_preferences;
struct _gfilerunner_plugin_preferences{
	/*TODO:  should this be a list of enabled or a list of disabled? (all on or off by default?)*/
	GList*enabled; /*this will be pointers to plugin/module structures*/
};

enum {GFILERUNNER_EXT_TEMPLATE=0,
	GFILERUNNER_EXT_SCRIPT,
	GFILERUNNER_EXT_MODULE} gfilerunner_ext_type;
typedef struct _gfilerunner_ext_usage_obj gfilerunner_ext_usage_obj;
struct _gfilerunner_ext_usage_obj{
	int stats; /* TODO:  When adding to stats, if we reach the LIMIT (set later) then divide/bitshift all things as to keep the same "proportions" */
	int type;
	char*filename; /* we will later compare using both the filename and type to be sure that we have the correct one */
};

/* TODO:  This should actually be a global.... (I think) */
typedef struct _gfilerunner_preferences gfilerunner_preferences;
struct _gfilerunner_preferences{
	char*file; /*FULL filename of the config file*/
	gfilerunner_locations_preferences*locations;
	gfilerunner_theme_preferences*theme;
	gfilerunner_graphics_preferences*graphics;
	gfilerunner_view_preferences*view_defaults;
	gfilerunner_speed_preferences*speed;
	gfilerunner_trash_preferences*trash;
	gfilerunner_disk_usage_preferences*disk_usage;
	gfilerunner_plugin_preferences*plugin;
	gfilerunner_userfriendly_preferences*userfriendly;
	GList*ext_usage_stats; /* GList of gfilerunner_ext_usage_obj's */
	/*	this will let us keep an list of "Open With","Scripts","Plugins" and anything else for the user's convienence of which they use the most often*/
};


/*FUNCTIONS*/
gfilerunner_preferences*gfilerunner_preferences_new(void);
void gfilerunner_preferences_load(gfilerunner_preferences*gfrprefs,const char*file);
void gfilerunner_preferences_sync(gfilerunner_preferences*gfrprefs);
#endif