/*
*  This contains most of the system related functions
*/
#include <config.h>
#include <sys/stat.h>
#include <glib.h>

#include "gfilerunner-sys.h"
#include "gfilerunner-theme-defs.h"

/*  TODO:  Get rid of this and let our URI description's user functions handle that...ie gfruridesc->modifier(teststr)  */
/* if teststr string ends with the specified character */
gboolean ends_with_delim(const char*teststr,char delim){
  int len=strlen(teststr);
  if(len>0){
    if(teststr[len-1]==delim){
      return TRUE;
    }
  }
  return FALSE;
}

/* argv is a NULL terminated vector of char*'s */
pid_t spawnvp(char**argv){
/* TODO:  Make a function or loop that will automagically clean up after zombie processes? */
  pid_t pid=fork();
  if(pid==-1)return(-1);
  if(pid>0){
   return(pid);
  }else{
   execvp(argv[0],argv);
   abort();
  }
}

char* get_command_output(const char*command){
	FILE*myprocess;
	char*tmpbuf=g_malloc(1024);
	char*buf="";
	int read;
	g_assert(tmpbuf!=NULL);
	fflush(NULL);
	if(!(myprocess=popen(command,"r"))) return(NULL);
	while(!feof(myprocess)){
		read=fread((void*)tmpbuf,1,1024,myprocess);
		tmpbuf[read]=0;
		buf=g_strconcat(buf,tmpbuf,NULL);
	}
	pclose(myprocess);
	g_free(tmpbuf);
	return(buf);
}

gboolean file_exists(const char*filename){
	struct stat *tmp=g_new(struct stat,1);
	int ret=stat(filename,tmp);
	g_free(tmp);
	if(ret==-1)return(FALSE);
	return(TRUE);
}

char*get_theme_ent(const char*theme,const char*filename){
	char*tstfile=g_strconcat(PACKAGE_THEMES_DIR,G_DIR_SEPARATOR_S,theme,G_DIR_SEPARATOR_S,filename,NULL);
	if(!file_exists(tstfile)){
		g_free(tstfile);
		tstfile=g_strconcat(PACKAGE_THEMES_DIR,G_DIR_SEPARATOR_S,GFILERUNNER_DEFAULT_THEME,G_DIR_SEPARATOR_S,filename,NULL);
	}
	return(tstfile);
}

gboolean get_str_bool(const char*str){
	if(strcasecmp(str,"yes")==0)return(TRUE);
	if(strcasecmp(str,"true")==0)return(TRUE);
	if(strcasecmp(str,"on")==0)return(TRUE);
	if(atoi(str)==1)return(TRUE);
	if(strcasecmp(str,"no")==0)return(FALSE);
	if(strcasecmp(str,"false")==0)return(FALSE);
	if(strcasecmp(str,"off")==0)return(FALSE);
	return(FALSE);
}

char*script_get_info_var(const char*script,const char*opt){
	char*cmd=g_strconcat(script," ",opt,NULL);
	char*retval=get_command_output(cmd);
	g_free(cmd);
	if(retval){
		if(strlen(retval)==0){
			g_free(retval);
			retval=NULL;
		}
	}
	return(retval);
}

char**script_get_info_array(const char*script,const char*opt){
	char*cmd=g_strconcat(script," ",opt,NULL);
	char*buf=get_command_output(cmd);
	char**retval=NULL;
	if(buf){
		retval=g_strsplit(buf,"\n",0);
	}else{
		retval=NULL;
	}
	g_free(buf);
	g_free(cmd);
	return(retval);
}

gboolean script_get_info_bool(const char*script,const char*opt){
	char*ret=script_get_info_var(script,opt);
	if(!ret) return(FALSE);
	g_free(ret);
	return(TRUE);
}
