#ifndef GFILERUNNER_TEMPLATE_H
#define GFILERUNNER_TEMPLATE_H

#include <glib.h>

#define GFILERUNNER_TEMPLATE_GET_INFO	"--get-info"
#define GFILERUNNER_TEMPLATE_FLAG_OVERIDE_DESIRED	"--overide-desired"
#define GFILERUNNER_TEMPLATE_FLAG_EXECUTE "--execute"
#define GFILERUNNER_TEMPLATE_ERROR "GFILERUNNER_TEMPLATE_ERROR"

typedef struct _gfilerunner_template gfilerunner_template;
struct _gfilerunner_template{
	char*file; /* full path to our actual template */
	char*name;
	char*version;
	char**authors;
	char*about;  /* this can be multilined, but we don't need to break it into a vector... */
	char*mime_type;
	char**dependancies;
	char*desired;
	gboolean local_only;
};

gfilerunner_template*gfilerunner_template_new(const char*path);
gfilerunner_template*gfilerunner_template_dup(gfilerunner_template*oldgfrtemplate);
char**gfilerunner_template_check_dependancies(gfilerunner_template*gfrtemplate);
void gfilerunner_template_free(gfilerunner_template*gfrtemplate);

#endif