/* gfilerunner-tree-object.c  -   by Kyle Davis
 *
 * This should allow GFileRunner's tree handler to have objects.
 */

#include "gfilerunner-tree-object.h"

gfilerunner_tree_object* gfilerunner_tree_object_new(const char*location,const char*desc,const char*collapse_pixbuf_file,const char*expand_pixbuf_file){
	gfilerunner_tree_object*gfrtree_object=g_new(gfilerunner_tree_object,1);
	GdkPixbuf*collapse_pixbuf=get_pixbuf(collapse_pixbuf_file);
	GdkPixbuf*expand_pixbuf=get_pixbuf(expand_pixbuf_file);
	GdkPixbuf*tmp=NULL;
	g_assert(gfrtree_object!=NULL);
	g_assert(expand_pixbuf!=NULL);
	g_assert(collapse_pixbuf!=NULL);
	gfrtree_object->location=g_strdup(location);
	if(desc!=NULL){
		gfrtree_object->desc=g_strdup(desc);
	}else{
		gfrtree_object->desc=NULL;
	}

	tmp=gdk_pixbuf_scale_simple(collapse_pixbuf,16,16,GDK_INTERP_HYPER);
	gdk_pixbuf_render_pixmap_and_mask(tmp,&gfrtree_object->collapse_pixmap,&gfrtree_object->collapse_mask,10);
	gdk_pixbuf_unref(tmp);

	tmp=gdk_pixbuf_scale_simple(expand_pixbuf,16,16,GDK_INTERP_HYPER);
	gdk_pixbuf_render_pixmap_and_mask(tmp,&gfrtree_object->expand_pixmap,&gfrtree_object->expand_mask,10);
	gdk_pixbuf_unref(tmp);

	gdk_pixbuf_unref(expand_pixbuf);
	gdk_pixbuf_unref(collapse_pixbuf);
	return(gfrtree_object);
}

gfilerunner_tree_object* gfilerunner_tree_object_new_noload(const char*location,const char*desc,
		GdkPixmap*cp,GdkBitmap*cb,GdkPixmap*ep,GdkBitmap*eb){
	gfilerunner_tree_object*gfrtree_object=g_new(gfilerunner_tree_object,1);
	g_assert(gfrtree_object!=NULL);
	gfrtree_object->location=g_strdup(location);
	if(desc!=NULL){
		gfrtree_object->desc=g_strdup(desc);
	}else{
		gfrtree_object->desc=NULL;
	}
	gfrtree_object->collapse_pixmap=(GdkPixmap*)g_memdup((gconstpointer)cp,sizeof(GdkPixmap));
	gfrtree_object->collapse_mask=(GdkBitmap*)g_memdup((gconstpointer)cb,sizeof(GdkBitmap));
	gfrtree_object->expand_pixmap=(GdkPixmap*)g_memdup((gconstpointer)ep,sizeof(GdkPixmap));
	gfrtree_object->expand_mask=(GdkBitmap*)g_memdup((gconstpointer)eb,sizeof(GdkBitmap));
	return(gfrtree_object);
}
void gfilerunner_tree_object_free(gfilerunner_tree_object* gfrtree_object){
	g_free(gfrtree_object->location);
	if(gfrtree_object->desc!=NULL) g_free(gfrtree_object->desc);
	gdk_pixmap_unref(gfrtree_object->expand_pixmap);
	gdk_bitmap_unref(gfrtree_object->expand_mask);
	gdk_pixmap_unref(gfrtree_object->collapse_pixmap);
	gdk_bitmap_unref(gfrtree_object->collapse_mask);
}
