//This will handle our URI's in a nice and neat way. (I think)

#ifndef GFILERUNNER_URI_H
#define GFILERUNNER_URI_H

#include <glib.h>

typedef char*(*gfilerunner_uri_humanize_func)(void*,const char*);
typedef char*(*gfilerunner_uri_modifier_func)(void*,const char*);
typedef struct _gfilerunner_uri_desc gfilerunner_uri_desc;
struct _gfilerunner_uri_desc{
	char*prefix;				//ie file:// or smb://
	char*rooturi;				//ie (/ in file:///) as compared to (NULL in smb://)
	gfilerunner_uri_modifier_func modifier;	//return a modified version of the URI that is sent to it...ie to deal with case sensitivity
	gfilerunner_uri_humanize_func humanize;	//return human readable string from URI as to what it should be displayed as...
//ie file:// to NULL, smb:// stays same?
//ie file:/// to MyComputer, smb:// to Local Network  (description)
};

//Simple URI descriptions to aid the automagic sorting of our tree...
gfilerunner_uri_desc* gfilerunner_uri_desc_new(char*prefix,char*rooturi,gfilerunner_uri_modifier_func modifier,gfilerunner_uri_humanize_func humanize);

//Free a URI description
void gfilerunner_uri_desc_free(gfilerunner_uri_desc*gfruri_desc);

#endif
