/*
 *  GFileRunner		by Kyle Davis
 *  
 *  GFileRunner and all its pertaining source code is under the GNU General Public License.
 *
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <libgnomevfs/gnome-vfs.h>

#include "support.h"
#include "interface.h"

/* TODO:  Nuke these in favor of some kind of multiple window handling system (to be implimented) */
gfilerunner_window*gfrwin=NULL;

int main(int argc, char *argv[]){
#ifdef ENABLE_NLS
	bindtextdomain(PACKAGE, PACKAGE_LOCALE_DIR);
	textdomain(PACKAGE);
#endif
	gnome_init("GFileRunner", VERSION, argc, argv);
	gfrprefs=gfilerunner_preferences_new();
	gfilerunner_preferences_load(gfrprefs,NULL);
	if(!gfrprefs){
		fprintf(stderr,"\nError creating preferences.\n");
		return(-1);
	}
	
	if(!gnome_vfs_init()){
		fprintf(stderr,"\nGnomeVFS didn't init..\n");
		return(-1);
	}
	if(argc>1){ /* TODO:  Figure out how to use popt maybe */
		gfrwin=gfilerunner_window_new(argv[argc-1]);
	}else{
		gfrwin=gfilerunner_window_new(argv[1]);
	}
	gtk_main();
	gnome_vfs_shutdown();
	return(0);
}
