/*
 *  GFileRunner         by Kyle Davis
 *  
 *  GFileRunner and all its pertaining source code is under the GNU General Public License.
 *
 */
//TODO:  Make this more modular...put everything into a struct...typedef that struct....
//this allows: easy access to everything in window, multiple windows easily, easy to manage multiple windows...
// you get the idea

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdk.h>
#include <gdk/gdkprivate.h>
#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "gfilerunner-desktop.h"
#include "gfilerunner-sys.h"

static GnomeUIInfo file1_menu_uiinfo[] ={
  GNOMEUIINFO_MENU_EXIT_ITEM (on_exit1_activate, NULL),
  GNOMEUIINFO_END
};
static GnomeUIInfo edit1_menu_uiinfo[] ={
  GNOMEUIINFO_MENU_CUT_ITEM(on_cut1_activate, NULL),
  GNOMEUIINFO_MENU_COPY_ITEM(on_copy1_activate, NULL),
  GNOMEUIINFO_MENU_PASTE_ITEM(on_paste1_activate, NULL),
  GNOMEUIINFO_ITEM(N_("_Rename"),"Rename selected file",on_rename1_activate,NULL),
  GNOMEUIINFO_ITEM(N_("_Trash"),"Delete selected files",on_delete1_activate,NULL),
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_MENU_PROPERTIES_ITEM(on_properties1_activate, NULL),
  GNOMEUIINFO_END
};
static GnomeUIInfo view1_menu_uiinfo[] ={
  GNOMEUIINFO_TOGGLEITEM(N_("_Anti-Aliasing"),N_("Turn on for better graphics, turn off for faster browsing."),on_view1_antialiasing_activate, NULL),
  GNOMEUIINFO_END
};
static GnomeUIInfo settings1_menu_uiinfo[] ={
  GNOMEUIINFO_MENU_PREFERENCES_ITEM (on_preferences1_activate, NULL),
  GNOMEUIINFO_END
};
static GnomeUIInfo go1_menu_uiinfo[]={
	GNOMEUIINFO_ITEM(N_("_Back"),"Back to previous",on_btnBack_clicked,NULL),
	GNOMEUIINFO_ITEM(N_("_Forward"),"Forward to previous",on_btnForward_clicked,NULL),
	GNOMEUIINFO_ITEM(N_("_Up"),"Up to parent directory",on_btnUp_clicked,NULL),
	GNOMEUIINFO_ITEM(N_("_Stop"),"Back to previous",on_btnStop_clicked,NULL),
	GNOMEUIINFO_ITEM(N_("_Refresh"),"Back to previous",on_btnRefresh_clicked,NULL),
	GNOMEUIINFO_ITEM(N_("_Home"),"Go to your home directory",on_btnHome_clicked,NULL),
	GNOMEUIINFO_END
};
static GnomeUIInfo tools1_menu_uiinfo[]={
	GNOMEUIINFO_END
};
static GnomeUIInfo help1_menu_uiinfo[] ={
  GNOMEUIINFO_MENU_ABOUT_ITEM (on_about1_activate, NULL),
  GNOMEUIINFO_END
};
static GnomeUIInfo menubar1_uiinfo[] ={
	GNOMEUIINFO_MENU_FILE_TREE(file1_menu_uiinfo),
	GNOMEUIINFO_MENU_EDIT_TREE(edit1_menu_uiinfo),
	GNOMEUIINFO_MENU_VIEW_TREE(view1_menu_uiinfo),
	GNOMEUIINFO_MENU_SETTINGS_TREE(settings1_menu_uiinfo),
	GNOMEUIINFO_SUBTREE(N_("_Go"),go1_menu_uiinfo),
	GNOMEUIINFO_SUBTREE(N_("_Tools"),tools1_menu_uiinfo),
	GNOMEUIINFO_MENU_HELP_TREE(help1_menu_uiinfo),
	GNOMEUIINFO_END
};

gfilerunner_window* gfilerunner_window_new(char*location){
	GtkWidget*dock;
	GtkWidget*toolbar;
	GtkWidget*tmp_toolbar_icon;
	GtkWidget*hbox;
	GtkWidget*lbllocation;
	GtkWidget*optionmenu;
	GtkWidget*optionmenu_menu;
	GtkWidget*glade_menuitem;
	GtkWidget*lblzoom;
	GtkObject*spinbutton_adj;
	GtkWidget*spinbutton;
	GtkWidget*hpaned;
	GtkWidget*scrolledwindow;
/*	GtkWidget*viewport; */
	GtkWidget*ctree;
	gfilerunner_window*gfrwin=g_new(gfilerunner_window,1);
	
	gfrwin->clocation=NULL;
	gfrwin->asyncvfs_handle=NULL;
	gfrwin->dequeue_handle=NULL;
	gfrwin->animation_handle=NULL;
	gfrwin->animation_idle_handle=NULL;
	gfrwin->is_scanning=FALSE;
	gfrwin->file_queue=NULL;
	gfrwin->animation_handle=NULL;
	gfrwin->canvas_group=NULL;
	gfrwin->lasso=NULL;
	gfrwin->selection=gfilerunner_clipboard_new();
	//FIXME:  clipboard init should go elsewhere
	gfrclipboard=gfilerunner_clipboard_new();

	gfrwin->window=gnome_app_new("GFileRunner",_("GFileRunner"));
	gtk_object_set_data(GTK_OBJECT(gfrwin->window), "gfilerunner", gfrwin->window);
	gtk_signal_connect(GTK_OBJECT(gfrwin->window),"delete_event",GTK_SIGNAL_FUNC(on_exit1_activate),NULL);
	//gtk_widget_show(gfrwin->window);
	
	dock=GNOME_APP(gfrwin->window)->dock;
	gtk_widget_ref(dock);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "dock",dock,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(dock);
	
	gnome_app_create_menus(GNOME_APP(gfrwin->window), menubar1_uiinfo);

	gtk_widget_ref (menubar1_uiinfo[0].widget);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "file1",menubar1_uiinfo[0].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (file1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "exit1",file1_menu_uiinfo[5].widget,(GtkDestroyNotify) gtk_widget_unref);
	 
	gtk_widget_ref (menubar1_uiinfo[1].widget);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "edit1",menubar1_uiinfo[1].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (edit1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "cut1",edit1_menu_uiinfo[0].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (edit1_menu_uiinfo[1].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "copy1",edit1_menu_uiinfo[1].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (edit1_menu_uiinfo[2].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "paste1",edit1_menu_uiinfo[2].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (edit1_menu_uiinfo[3].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "rename1",edit1_menu_uiinfo[3].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (edit1_menu_uiinfo[4].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "delete1",edit1_menu_uiinfo[4].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (edit1_menu_uiinfo[5].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "separator2",edit1_menu_uiinfo[5].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (edit1_menu_uiinfo[6].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "properties1",edit1_menu_uiinfo[6].widget,(GtkDestroyNotify) gtk_widget_unref);
	 
	gtk_widget_ref (menubar1_uiinfo[2].widget);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "view1",menubar1_uiinfo[2].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (view1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "toggle_aa",view1_menu_uiinfo[0].widget,(GtkDestroyNotify) gtk_widget_unref);
	
	gtk_widget_ref (menubar1_uiinfo[3].widget);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "settings1",menubar1_uiinfo[3].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (settings1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "preferences1",settings1_menu_uiinfo[0].widget,(GtkDestroyNotify) gtk_widget_unref);

	gtk_widget_ref (menubar1_uiinfo[4].widget);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "go1",menubar1_uiinfo[4].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (go1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "back",go1_menu_uiinfo[0].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (go1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "forward",go1_menu_uiinfo[1].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (go1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "up",go1_menu_uiinfo[2].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (go1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "stop",go1_menu_uiinfo[3].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (go1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "refresh",go1_menu_uiinfo[4].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (go1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "home",go1_menu_uiinfo[5].widget,(GtkDestroyNotify) gtk_widget_unref);
	
	gtk_widget_ref(menubar1_uiinfo[5].widget);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window),"tools1",menubar1_uiinfo[5].widget,(GtkDestroyNotify)gtk_widget_unref);

	gtk_widget_ref (menubar1_uiinfo[6].widget);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "help1",menubar1_uiinfo[6].widget,(GtkDestroyNotify) gtk_widget_unref);
		gtk_widget_ref (help1_menu_uiinfo[0].widget);
		gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "about1",help1_menu_uiinfo[0].widget,(GtkDestroyNotify) gtk_widget_unref);
	 
	toolbar = gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
	gtk_widget_ref(toolbar);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "toolbar", toolbar,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(toolbar);
	gnome_app_add_toolbar(GNOME_APP(gfrwin->window), GTK_TOOLBAR (toolbar), "toolbar",GNOME_DOCK_ITEM_BEH_EXCLUSIVE,GNOME_DOCK_TOP, 1, 0, 0);
	gtk_toolbar_set_space_size(GTK_TOOLBAR(toolbar), 8);
	gtk_toolbar_set_space_style(GTK_TOOLBAR(toolbar), GTK_TOOLBAR_SPACE_LINE);
	gtk_toolbar_set_button_relief(GTK_TOOLBAR(toolbar), GTK_RELIEF_NONE);
	gtk_toolbar_set_style(GTK_TOOLBAR(toolbar),GTK_TOOLBAR_BOTH);  //ICONS,TEXT,BOTH
 	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_BACK),24,24);
	gfrwin->btnBack = gtk_toolbar_append_element(GTK_TOOLBAR(toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Back"),_("Back"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref(gfrwin->btnBack);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "btnBack", gfrwin->btnBack,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(gfrwin->btnBack);
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_FORWARD),24,24);
	gfrwin->btnForward = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Forward"),_("Forward"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnForward);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnForward", gfrwin->btnForward,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnForward);
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_UP),24,24);
	gfrwin->btnUp = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Up"),_("Parent Directory"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnUp);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnUp", gfrwin->btnUp,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnUp);
	
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_STOP),24,24);
	gfrwin->btnStop = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Stop"),_("Stop Scanning"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnStop);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnStop", gfrwin->btnStop,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnStop);
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_REFRESH),24,24);
	gfrwin->btnRefresh = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Refresh"),_("Refresh Current Directory"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnRefresh);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnRefresh", gfrwin->btnRefresh,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnRefresh);
	
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_CUT),24,24);
	gfrwin->btnCut = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Cut"),_("\"Cut\""), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnCut);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnCut", gfrwin->btnCut,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnCut);
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_COPY),24,24);
	gfrwin->btnCopy = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Copy"),_("Copy"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnCopy);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnCopy", gfrwin->btnCopy,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnCopy);
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_PASTE),24,24);
	gfrwin->btnPaste = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Paste"),_("Paste"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnPaste);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnPaste", gfrwin->btnPaste,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnPaste);
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_TRASH),24,24);
	gfrwin->btnTrash = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Trash"),_("Move selected to trash"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnTrash);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnTrash", gfrwin->btnTrash,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnTrash);
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_UNDO),24,24);
	gfrwin->btnUndo = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Undo"),_("Undo Previous Action"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnUndo);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnUndo", gfrwin->btnUndo,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnUndo);
	
	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
	
	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_SEARCH),24,24);
	gfrwin->btnSearch = gtk_toolbar_append_element(GTK_TOOLBAR(toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Search"),_("Search for files"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref(gfrwin->btnSearch);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "btnSearch", gfrwin->btnSearch,(GtkDestroyNotify)gtk_widget_unref);
	gtk_widget_show(gfrwin->btnSearch);
	
	gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

	tmp_toolbar_icon = gnome_stock_pixmap_widget_at_size(gfrwin->window,get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_HOME),24,24);
	gfrwin->btnHome = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),GTK_TOOLBAR_CHILD_BUTTON,NULL,_("Home"),_("Go to your home directory"), NULL,tmp_toolbar_icon, NULL, NULL);
	gtk_widget_ref (gfrwin->btnHome);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "btnHome", gfrwin->btnHome,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (gfrwin->btnHome);
	
	hbox = gtk_hbox_new(FALSE,0);
	gtk_widget_ref(hbox);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "hbox", hbox,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(hbox);
	gnome_app_add_docked(GNOME_APP (gfrwin->window), hbox, "hbox",GNOME_DOCK_ITEM_BEH_EXCLUSIVE|GNOME_DOCK_ITEM_BEH_NEVER_VERTICAL,GNOME_DOCK_TOP,2,0,3);
	gtk_container_set_border_width(GTK_CONTAINER(hbox), 8);
	
	lbllocation = gtk_label_new (_("Location:"));
	gtk_widget_ref(lbllocation);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "lbllocation", lbllocation,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show(lbllocation);
	gtk_box_pack_start(GTK_BOX (hbox), lbllocation, FALSE, FALSE, 0);
	gtk_label_set_justify(GTK_LABEL (lbllocation), GTK_JUSTIFY_RIGHT);
	gtk_misc_set_padding(GTK_MISC (lbllocation), 8, 0);
	
	gfrwin->location=gtk_entry_new();
	gtk_widget_ref(gfrwin->location);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window),"location",gfrwin->location,(GtkDestroyNotify)gtk_widget_unref);
	if(location==NULL){
		gtk_entry_set_text(GTK_ENTRY(gfrwin->location),g_get_home_dir());
		if(!ends_with_delim(gtk_entry_get_text(GTK_ENTRY(gfrwin->location)),GNOME_VFS_URI_PATH_CHR)){
			gtk_entry_append_text(GTK_ENTRY(gfrwin->location),GNOME_VFS_URI_PATH_STR);
		}
	}else{
		gtk_entry_set_text(GTK_ENTRY(gfrwin->location),location);
		if(!ends_with_delim(gtk_entry_get_text(GTK_ENTRY(gfrwin->location)),GNOME_VFS_URI_PATH_CHR)){
			gtk_entry_append_text(GTK_ENTRY(gfrwin->location),GNOME_VFS_URI_PATH_STR);
		}
	}
	gtk_widget_show(gfrwin->location);
	gtk_box_pack_start(GTK_BOX(hbox),gfrwin->location,TRUE,TRUE,0);

	gfrwin->btnGo = gtk_button_new_with_label(_(" Go "));
	gtk_widget_ref(gfrwin->btnGo);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "btnGo", gfrwin->btnGo,(GtkDestroyNotify)gtk_widget_unref);
	gtk_widget_show(gfrwin->btnGo);
	gtk_box_pack_start(GTK_BOX(hbox), gfrwin->btnGo, FALSE, FALSE, 10);
	gtk_button_set_relief(GTK_BUTTON(gfrwin->btnGo), GTK_RELIEF_HALF);
	
	lblzoom = gtk_label_new(_("Zoom:"));
	gtk_widget_ref(lblzoom);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "lblzoom", lblzoom, (GtkDestroyNotify)gtk_widget_unref);
	gtk_widget_show(lblzoom);
	gtk_box_pack_start (GTK_BOX (hbox), lblzoom, FALSE, FALSE, 5);
	gtk_misc_set_alignment (GTK_MISC (lblzoom), 1, 0.5);
	gtk_misc_set_padding (GTK_MISC (lblzoom), 5, 0);
	
	spinbutton_adj=gtk_adjustment_new(100, 25, 400, 25, 25, 25);
	spinbutton=gtk_spin_button_new(GTK_ADJUSTMENT(spinbutton_adj), 1, 0);
	gtk_widget_ref(spinbutton);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window),"spinbutton",spinbutton,(GtkDestroyNotify)gtk_widget_unref);
	gtk_widget_show(spinbutton);
	gtk_box_pack_start(GTK_BOX(hbox), spinbutton, FALSE, FALSE, 0);
	gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(spinbutton),TRUE);
	
	optionmenu=gtk_option_menu_new();
	gtk_widget_ref(optionmenu);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window),"optionmenu",optionmenu,(GtkDestroyNotify)gtk_widget_unref);
	gtk_widget_show(optionmenu);
	gtk_box_pack_start(GTK_BOX(hbox), optionmenu, FALSE, FALSE, 5);
	optionmenu_menu=gtk_menu_new();
	glade_menuitem=gtk_menu_item_new_with_label(_("Icon View"));
	gtk_widget_show(glade_menuitem);
	gtk_menu_append(GTK_MENU(optionmenu_menu),glade_menuitem);
	glade_menuitem=gtk_menu_item_new_with_label(_("List View"));
	gtk_widget_show(glade_menuitem);
	gtk_menu_append(GTK_MENU(optionmenu_menu),glade_menuitem);
	gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu),optionmenu_menu);

	hpaned = gtk_hpaned_new ();
	gtk_widget_ref (hpaned);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "hpaned", hpaned,(GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hpaned);
	gnome_app_set_contents (GNOME_APP (gfrwin->window), hpaned);
	gtk_widget_set_usize (hpaned, 400, 300);
	gtk_paned_set_position (GTK_PANED (hpaned), 200);
	 
	scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_ref (scrolledwindow);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "scrolledwindow", scrolledwindow,(GtkDestroyNotify) gtk_widget_unref);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_widget_show (scrolledwindow);
	gtk_paned_pack1 (GTK_PANED (hpaned), scrolledwindow, FALSE, TRUE);
	
	//viewport = gtk_viewport_new (NULL, NULL);
	//gtk_widget_ref (viewport);
	//gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "viewport", viewport,(GtkDestroyNotify) gtk_widget_unref);
	//gtk_widget_show (viewport);
	//gtk_container_add (GTK_CONTAINER (scrolledwindow), viewport);
	
	ctree=gtk_ctree_new(1,0);
	gtk_ctree_set_line_style(GTK_CTREE(ctree),GTK_CTREE_LINES_SOLID);
	gtk_ctree_set_expander_style(GTK_CTREE(ctree),GTK_CTREE_EXPANDER_SQUARE);
	gtk_widget_ref(ctree);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "ctree", ctree, (GtkDestroyNotify)gtk_widget_unref);
	gtk_widget_show(ctree);
	gtk_container_add (GTK_CONTAINER (scrolledwindow), ctree);
	
	gfrwin->gfrtree=gfilerunner_tree_new(ctree,
			get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_TINY_FOLDER),
			get_theme_ent(gfrprefs->theme->theme_prefix,GFILERUNNER_TINY_FOLDER_OPEN));
//TODO: This should be moved to when the module code is put into place.
	gfilerunner_tree_register_uri_desc(gfrwin->gfrtree,gfilerunner_uri_desc_new("file://","file:///",
																(gfilerunner_uri_modifier_func)filemod_uri_modifier,
																(gfilerunner_uri_humanize_func)filemod_uri_humanize));
	
	gfrwin->scrolledwindowRHS = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_ref (gfrwin->scrolledwindowRHS);
	gtk_object_set_data_full (GTK_OBJECT(gfrwin->window), "gfrwin->scrolledwindowRHS", gfrwin->scrolledwindowRHS,(GtkDestroyNotify) gtk_widget_unref);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (gfrwin->scrolledwindowRHS), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_widget_show (gfrwin->scrolledwindowRHS);
	gtk_paned_pack2 (GTK_PANED (hpaned), gfrwin->scrolledwindowRHS, TRUE, TRUE);
	
	gfrwin->appbar=gnome_appbar_new(TRUE, TRUE, GNOME_PREFERENCES_NEVER);
	gtk_widget_ref(gfrwin->appbar);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window), "gfrwin->appbar", gfrwin->appbar,(GtkDestroyNotify)gtk_widget_unref);
	gtk_widget_show(gfrwin->appbar);

	gnome_app_set_statusbar(GNOME_APP(gfrwin->window), gfrwin->appbar);
	gnome_app_install_menu_hints(GNOME_APP(gfrwin->window), menubar1_uiinfo);
	
	gtk_signal_connect(GTK_OBJECT(gfrwin->window),"check_resize",GTK_SIGNAL_FUNC(on_gfilerunner_check_resize),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->window), "motion_notify_event",GTK_SIGNAL_FUNC(on_gfilerunner_motion_notify_event),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnGo),"clicked",GTK_SIGNAL_FUNC(on_btnGo_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnBack), "clicked",GTK_SIGNAL_FUNC(on_btnBack_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnForward), "clicked",GTK_SIGNAL_FUNC(on_btnForward_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnUp), "clicked",GTK_SIGNAL_FUNC(on_btnUp_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnStop), "clicked",GTK_SIGNAL_FUNC(on_btnStop_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnRefresh), "clicked",GTK_SIGNAL_FUNC(on_btnRefresh_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnCut), "clicked",GTK_SIGNAL_FUNC(on_btnCut_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnCopy), "clicked",GTK_SIGNAL_FUNC(on_btnCopy_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnPaste), "clicked",GTK_SIGNAL_FUNC(on_btnPaste_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnTrash), "clicked",GTK_SIGNAL_FUNC(on_btnTrash_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnUndo), "clicked",GTK_SIGNAL_FUNC(on_btnUndo_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnSearch), "clicked",GTK_SIGNAL_FUNC(on_btnSearch_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(gfrwin->btnHome), "clicked",GTK_SIGNAL_FUNC(on_btnHome_clicked),NULL);
	gtk_signal_connect(GTK_OBJECT(ctree),"tree-select-row",GTK_SIGNAL_FUNC(on_ctree_row_select),NULL);

	gtk_widget_show(gfrwin->window); //Just in case I'll just do show all....

/*TODO:  Lose this, this is used right now to tell when it is safe to draw*/
	gdk_rgb_init();
	gtk_widget_push_visual(gdk_rgb_get_visual());
	gtk_widget_push_colormap(gdk_rgb_get_cmap());
	gfrwin->canvas=gnome_canvas_new();
	gtk_widget_pop_colormap();
	gtk_widget_pop_visual();
	gtk_widget_ref(gfrwin->canvas);
	gtk_object_set_data_full(GTK_OBJECT(gfrwin->window),"canvas",gfrwin->canvas,(GtkDestroyNotify)gtk_widget_unref);
	gtk_container_add(GTK_CONTAINER(gfrwin->scrolledwindowRHS),gfrwin->canvas);
	gnome_canvas_set_dither(GNOME_CANVAS(gfrwin->canvas),GDK_RGB_DITHER_NONE);


	gtk_signal_connect(GTK_OBJECT(gfrwin->canvas), "draw",GTK_SIGNAL_FUNC(on_canvas_realize),NULL); 
	gtk_signal_connect(GTK_OBJECT(gfrwin->canvas), "destroy_event",GTK_SIGNAL_FUNC(on_canvas_destroy_event),NULL);

	gtk_widget_show(gfrwin->canvas);

	return gfrwin;
}
void gfilerunner_window_show_lasso(gfilerunner_window*gfrwin,gfloat x1,gfloat y1,gfloat x2,gfloat y2){
	if(!gfrwin->lasso){
		char mystipple[]={170,NULL};
		GdkBitmap*stipple=gdk_bitmap_create_from_data(NULL,mystipple,4,2);
		gfrwin->lasso=gfilerunner_lasso_new(GNOME_CANVAS_GROUP(gfrwin->canvas_group),x1,y1,x2,y2,0x4444FF22,stipple,0x00006622);
	}else{
		gfilerunner_lasso_moveto(gfrwin->lasso,x1,y1,x2,y2);
	}
}
void gfilerunner_window_hide_lasso(gfilerunner_window*gfrwin){
	if(gfrwin->lasso){
		gfilerunner_lasso_free(gfrwin->lasso);
		gfrwin->lasso=NULL;
	}
}

void gfilerunner_window_clear_selection(gfilerunner_window*gfrwin){
	gfilerunner_vfs_obj*vfsobj=NULL;
	GList*listitem=gfrwin->selection->data;
	while(listitem){
		vfsobj=(gfilerunner_vfs_obj*)listitem->data;
		if(vfsobj) basic_icon_unhighlight(vfsobj->icon);
		listitem=listitem->next;
	}
	gfilerunner_clipboard_flush(gfrwin->selection);
}

void gfilerunner_window_refresh_selection(gfilerunner_window*gfrwin){
	gfilerunner_vfs_obj*vfsobj=NULL;
	GList*listitem=gfrwin->selection->data;
	while(listitem){
		vfsobj=(gfilerunner_vfs_obj*)listitem->data;
		if(vfsobj) basic_icon_highlight(vfsobj->icon);
		listitem=listitem->next;
	}
}

void gfilerunner_window_free(gfilerunner_window*gfrwin){
	gfilerunner_clipboard_free(gfrwin->selection);
	fprintf(stderr,"fixme:  in gfilerunner_window_free(): nothing was freed\n");
}
